From d8ed17d821fcd9fe8e1373fd1a7e9f8da88030de Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Aug 31 2017 14:29:42 +0000
Subject: [PATCH 942/1001] Fix logout and abusive reuse of auth info


---

diff --git a/hubs/app.py b/hubs/app.py
index c24a9e0..8974ae4 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -67,7 +67,12 @@ def check_auth():
     flask.g.fedmsg_config = fedmsg_config
 
     if OIDC.user_loggedin:
-        if "auth" not in flask.session or not flask.session["auth"]:
+        # The "sub" value is unique per user, and does not make an HTTP API
+        # request.
+        user_sub = OIDC.user_getfield("sub")
+        if ("auth" not in flask.session
+            or not flask.session["auth"]
+            or flask.session["auth"]["sub"] != user_sub):
             user_info = OIDC.user_getinfo([
                 "name", "nickname", "sub", "email", "zoneinfo", "cla",
                 "groups",
@@ -80,6 +85,7 @@ def check_auth():
                 cla_done=('http://admin.fedoraproject.org/accounts/cla/done'
                           in user_info['cla']),
                 groups=user_info['groups'],
+                sub=user_info['sub'],
                 logged_in=True,
             )
             flask.session["auth"]["avatar"] = username2avatar(
@@ -95,6 +101,7 @@ def check_auth():
     else:
         flask.g.auth = munch.Munch(logged_in=False)
         flask.g.user = None
+        OIDC.logout()
 
 
 # Register widgets
diff --git a/hubs/views/root.py b/hubs/views/root.py
index be77ce6..132647d 100644
--- a/hubs/views/root.py
+++ b/hubs/views/root.py
@@ -66,7 +66,7 @@ def logout():
 
     if authenticated():
         OIDC.logout()
-        flask.session.auth = None
+        flask.session.clear()
         flask.flash('You have been logged out')
 
     return flask.redirect(next_url)

